import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Person)
include("UtilPThings.lua")
include("UtilRefs.lua")
include("LibBuildings.lua")
include("LibSpells.lua")
include("LibKillPrayer.lua")

local ReincPos = {
  MAP_XZ_2_WORLD_XYZ(38, 160),
  MAP_XZ_2_WORLD_XYZ(160, 204)
}

blueShamanOwner = 0
VaultPrayKiller = 0
currentVolcanoEruption = 1
volcanoEruptionLocations = {}
eruptionStarterAltitudes = {}
lightningBoltLocations = {}

for i,k in ipairs(ReincPos) do
  local me = world_coord3d_to_map_ptr(k)
  me.MapWhoList:processList(function(t)
    if (t.Type == T_PERSON) then
      if (t.Model == M_PERSON_MEDICINE_MAN) then
        if (i == 1) then
          blueShamanOwner = t.Owner
          VaultPrayKiller = KillPrayer:new(nil, 98, 76, 98, 80, blueShamanOwner, 0)
        end
        if (i == 2) then
          EnableSpell(t.Owner, M_SPELL_VOLCANO)
        end
      end
    end
    return true
  end)
end

function AddVolcanoEruption(x, z)
  local c2d = Coord2D.new()
  map_xz_to_world_coord2d(x, z, c2d)
  table.insert(volcanoEruptionLocations, c2d)
  table.insert(eruptionStarterAltitudes, point_altitude(c2d.Xpos, c2d.Zpos))
end

function AddLightningBolt(x, z)
  local c2d = Coord2D.new()
  map_xz_to_world_coord2d(x, z, c2d)
  table.insert(lightningBoltLocations, c2d)
end

function OnTurn()
  VaultPrayKiller:CheckIncorrectShamanPraying()

  if (GetTurn() == 12) then
    AddVolcanoEruption(36, 124)
    AddVolcanoEruption(58, 190)
    AddVolcanoEruption(144, 66)
    AddVolcanoEruption(92, 194)
    AddVolcanoEruption(94, 64)
    AddLightningBolt(182, 114)
    AddLightningBolt(216, 102)
    AddLightningBolt(230, 114)
    AddLightningBolt(250, 138)
    AddLightningBolt(224, 170)
    AddLightningBolt(216, 178)
    AddLightningBolt(202, 142)
    AddLightningBolt(180, 152)
    AddLightningBolt(158, 154)
    AddLightningBolt(156, 178)
    AddLightningBolt(172, 172)
    AddLightningBolt(182, 190)
    AddLightningBolt(176, 134)
    AddLightningBolt(148, 116)
    AddLightningBolt(132, 142)
    AddLightningBolt(198, 130)
  end

  if (everyPow(360, 1)) then
    local lightningLocationsCount = #lightningBoltLocations
    local lightningLocation = G_RANDOM(lightningLocationsCount) + 1
    local c3d = Coord3D.new()
    coord2D_to_coord3D(lightningBoltLocations[lightningLocation], c3d)
    createThing(T_EFFECT, M_EFFECT_LIGHTNING_BOLT, TRIBE_NEUTRAL, c3d, false, false)
  end

  if (everyPow(1980, 1)) then
      if (currentVolcanoEruption <= 5) then
        if (point_altitude(volcanoEruptionLocations[currentVolcanoEruption].Xpos, volcanoEruptionLocations[currentVolcanoEruption].Zpos) > eruptionStarterAltitudes[currentVolcanoEruption]) then
          --Dont do anything, land is repaired :)
        else
          local c3d = Coord3D.new()
          coord2D_to_coord3D(volcanoEruptionLocations[currentVolcanoEruption], c3d)
          createThing(T_EFFECT, M_EFFECT_VOLCANO_EXPLOSIONS, TRIBE_NEUTRAL, c3d, false, false)
          createThing(T_EFFECT, M_EFFECT_VOLCANO, TRIBE_NEUTRAL, c3d, false, false)
        end

        currentVolcanoEruption = currentVolcanoEruption + 1
      end
  end
end